#include <bits/stdc++.h>
using namespace std;

const int inf = 1e9;
const int maxn = 1e4;
char s[ maxn ];
map< char, int > to[ maxn ];
int len[ maxn ], spos[ maxn ], link[ maxn ];
int node, pos;
int sz = 1, n = 0;

int make_node( int _pos, int _len ) {
   spos[ sz ] = _pos;
   len[ sz ] = _len;
   return sz++;
}

void go_edge( void ) {
   while( pos > len[ to[ node ][ s[ n - pos ] ] ] ) {
      node = to[ node ][ s[ n - pos ] ];
      pos -= len[ node ];
   }
}

void add_letter( char c ) {
   s[ n++ ] = c;
   pos++;
   int last = 0;
   while( pos > 0 ) {
      go_edge();
      int edge = s[ n - pos ];
      int &v = to[ node ][ edge ];
      int t = s[ spos[ v ] + pos - 1 ];
      if( v == 0 ) {
         v = make_node( n - pos, inf );
         link[ last ] = node;
         last = 0;
      }
      else if( t == c ) {
         link[ last ] = node;
         return;
      }
      else {
         int u = make_node( spos[ v ], pos - 1 );
         to[ u ][ c ] = make_node( n - 1, inf );
         to[ u ][ t ] = v;
         spos[ v ] += pos - 1;
         len[ v ] -= pos - 1;
         v = u;
         link[ last ] = u;
         last = u;
      }
      if( node == 0 )
         pos--;
      else
         node = link[ node ];
   }
}

void show( void ) {
   cout << "{pos,len,link}: ";
   for( int i = 1; i < sz; i++ ) 
      cout << "{" << i << ":" << spos[ i ] << "," << len[ i ] << ","  << link[ i ] << "} ";
   cout << endl;
   for( int i = 0; i < sz; i++ ) {
      cout << i << ": map size " << to[ i ].size() << " : ";
      for( auto &x : to[ i ] )
         cout << "[" << (char)x.first << "," << x.second << "] ";
      cout << endl;
   }
}

string sinp;

void image_node( pair< const char, int >& n ) {
   int i = n.second;
   cout << "<" << n.second << ">" << n.first
        << "[" << spos[ i ] << ":" << len[ i ] << "]:" 
        << string( s ).substr( spos[ i ], len[ i ] ) << endl;    
}

void show_tree( int layer, int levl );

void put_node( pair< const char, int >& n, int levl ) {
   for( int i = 0; i < levl; i++ ) cout << '\t'; 
   image_node( n );
   int i = n.second;
   if( !to[ i ].empty() )
      show_tree( i, levl + 1 );
}

void show_tree( int layer = 0, int levl = 0 ) {
   for( auto &n : to[ layer ] )
      put_node( n, levl );
}

int main() {
   while( true ) {
      sz = 1; n = node = pos = 0; len[ 0 ] = inf;
      for( auto &m : to ) m.clear();
      cout << "> ";
      getline( cin, sinp );
      for( unsigned i = 0; i < sinp.size(); i++ ) 
         add_letter( sinp[ i ] );
      for( int i = 1; i < sz; i++ )      
         len[ i ] = min( (int)strlen( s ) - spos[ i ], len[ i ] );         
      show();         
      cout << "узлов " << sz << " рёбер " << sz - 1 << " длиной:" << endl;
      int ans = 0;
      for( int i = 1; i < sz; i++ ) {
         int l = min( (int)sinp.size() - spos[ i ], len[ i ] );
         ans += l;
         cout << l << "  ";
      }
      cout << "=> " << ans << endl;
      show_tree();
   }
}
