#include <bits/stdc++.h>
using namespace std;

const int MAXLEN = 600000; 
string s;
int pos[ MAXLEN ], len[ MAXLEN ], par[ MAXLEN ];
int path[ MAXLEN ];
map< char,int > to[ MAXLEN ], link[ MAXLEN ];
int sz;

void attach( int child, int parent, char c, int child_len ) {
   to[ parent ][ c ] = child;
   len[ child ] = child_len;
   par[ child ] = parent;
}

void extend( int i ) {
   int v, vlen = s.size() - i, old = sz - 1, pstk = 0; 
   for( v = old; !link[ v ].count( s[ i ] ); v = par[ v ] ) {
      vlen -= len[ v ];
      path[ pstk++ ] = v;
   }
   int w = link[ v ][ s[ i ] ]; 
   if( to[ w ].count( s[ i + vlen ] ) ) {
      int u = to[ w ][ s[ i + vlen ] ]; 
      for( pos[ sz ] = pos[ u ] - len[ u ]; s[ pos[ sz ] ] == s[ i + vlen ]; pos[ sz ] += len[ v ] ) {
         v = path[--pstk];
         vlen += len[v];
      }
      attach( sz, w, s[ pos[ u ] - len[ u ] ], len[ u ] - ( pos[ u ] - pos[ sz ] ) );
      attach( u, sz, s[ pos[ sz ] ], pos[ u ] - pos[ sz ] );
      w = link[ v ][ s[ i ] ] = sz++;
   }
   link[ old ][ s[ i ] ] = sz;
   attach( sz, w, s[ i + vlen ], s.size() - ( i + vlen ) );
   pos[ sz++ ] = s.size();
}

void show( void ) {
   cout << "{pos,len,par}: ";
   for( int i = 1; i < sz; i++ ) 
      cout << "{" << i << ":" << pos[ i ] << "," << len[ i ] << "," << par[ i ] << "} ";
   cout << endl;
   for( int i = 1; i < sz; i++ ) {
      cout << i << ": map size " << to[ i ].size() << " : ";
      for( auto &x : to[ i ] )
         cout << "[" << (char)x.first << "," << x.second << "] ";
      cout << endl;
   }
}

void image_node( pair< const char, int >& n ) {
   int i = n.second;
   cout << "<" << n.second << ">" << n.first
        << "[" << pos[ i ] - len[ i ] << ":" << len[ i ] << "]:" 
        << string( s ).substr( pos[ i ] - len[ i ], len[ i ] ) << endl;
}

void show_tree( int layer, int levl );
   
void put_node( pair< const char, int >& n, int levl ) {
   for( int i = 0; i < levl; i++ ) cout << '\t';
   image_node( n );
   int i = n.second;
   if( !to[ i ].empty() )
      show_tree( i, levl + 1 );
}

void show_tree( int layer = 1, int levl = 0 ) {
   for( auto &n : to[ layer ] )
      put_node( n, levl );
}

int main() {
   while( true ) {
      for( auto &m : to ) m.clear();
      for( auto &m : link ) m.clear();
      sz = 2;
      len[ 1 ] = 1; pos[ 1 ] = 0; par[ 1 ] = 0;
      for( int c = 0; c < 256; c++ )
	 link[ 0 ][ c ] = 1; 
      cout << "> ";
      getline( cin, s );
      for( int i = s.size() - 1; i >= 0; i-- )
	 extend( i );
      show();
      cout << "узлов " << sz - 1 << " рёбер " << sz - 2 << " длиной:" << endl;
      int ans = 0;
      for( int i = 2; i < sz; i++ ) {
         ans += len[ i ];
         cout << len[ i ] << "  ";
      }
      cout << "=> " << ans << endl;
      show_tree();
   }
}
